<?php namespace Phpcmf\Model\Bdxz;

class Bdxz extends \Phpcmf\Model
{

    private $zzurl = [
        'add' => 'http://data.zz.baidu.com/urls',
        'edit' => 'http://data.zz.baidu.com/update',
        'del' => 'http://data.zz.baidu.com/del',
    ];



    private $zzconfig;

    // 配置信息
    public function getConfig() {

        if ($this->zzconfig) {
            return $this->zzconfig;
        }

        if (is_file(WRITEPATH.'config/bdxz.php')) {
            $this->zzconfig = require WRITEPATH.'config/bdxz.php';
            return $this->zzconfig;
        }

        return [];
    }

    // 配置信息
    public function setConfig($data) {

        \Phpcmf\Service::L('Config')->file(WRITEPATH.'config/bdxz.php', '站长配置文件', 32)->to_require($data);

    }


    // 进行百度推送
    public function module_bdxz($mid, $url, $action = 'add') {

        $config = $this->getConfig();
        if (!$config) {
            return;
        } elseif (!$config['use']) {
            return;
        }

        $uri = parse_url($url);
        $site = $uri['host'];
        if (!$site) {
            return;
        }

        // 获取移动端域名
        $murl = dr_url_prefix('test.html', $mid, SITE_ID, 1);
        $uri = parse_url($murl);
        $m_site = $uri['host'];
        if ($m_site && $m_site != $site) {
            $murl = str_replace($site, $m_site, $url); // 替换移动端url
        } else {
            $m_site = '';
        }


        // 百度熊掌更新
        if ($action == 'add' && $config['bdxz']) {
            $appid = '';
            $token = '';
            $m_appid = '';
            $m_token = '';
            foreach ($config['bdxz'] as $t) {
                if ($t['site'] == $site && !$token) {
                    $token = $t['token'];
                    $appid = $t['appid'];
                }
                if ($m_site && $t['site'] == $m_site && !$m_appid) {
                    $m_token = $t['token'];
                    $m_appid = $t['appid'];
                }
            }
            if ($token && $appid) {
                $urls = [$url];
                $this->bdxz($appid, $token, $urls, 'realtime');
            }
            if ($m_appid && $m_token) {
                $urls = [$murl];
                $this->bdxz($m_appid, $m_token, $urls, 'realtime');
            }
        }

    }

    // 推送百度熊掌号
    public function bdxz($appid, $token, $urls, $type = 'realtime') {
        $api = 'http://data.zz.baidu.com/urls?appid='.$appid.'&token='.$token.'&type='.$type;
        $ch = curl_init();
        $options =  array(
            CURLOPT_URL => $api,
            CURLOPT_POST => true,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POSTFIELDS => implode("\n", $urls),
            CURLOPT_HTTPHEADER => array('Content-Type: text/plain'),
        );
        curl_setopt_array($ch, $options);
        $rt = json_decode(curl_exec($ch), true);

        if ($rt['error']) {
            // 错误日志
            @file_put_contents(WRITEPATH.'bdxz_log.php', date('Y-m-d H:i:s').' ['.dr_count($urls).'个url] - 失败 - '.$rt['message'].PHP_EOL, FILE_APPEND);
            return dr_return_data(0, $rt['message']);
        } else {
            // 推送成功
            @file_put_contents(WRITEPATH.'bdxz_log.php', date('Y-m-d H:i:s').' ['.dr_count($urls).'个url] - 成功'.PHP_EOL, FILE_APPEND);
        }


        return dr_return_data(1, $rt['message']);
    }


}