<?php namespace Phpcmf\Controllers;

class Home extends \Phpcmf\Home\Module

{


    //自动发布
    public function index()
    {
        $msg = '';

        //获取设置
        $config = \Phpcmf\Service::M('mokhtml', 'mokhtml')->getConfig();


        if (!$config['open'] || $config['open'] != 1) {
            return $msg . '未开启';
        }

        $id = \Phpcmf\Service::L('input')->get('id');
        $catid = \Phpcmf\Service::L('input')->get('catid');
        $mod = \Phpcmf\Service::L('input')->get('mod');
        $isadd = \Phpcmf\Service::L('input')->get('isadd');

        //参数不全
        if (!$id && !$catid) {
            return $msg . '参数不全';
        }

        //未选中栏目
        if (!in_array($catid, $config['catid'])) {
            return $msg . '无效';
        }

        //编辑还是新增
        if ($isadd == 1 && $config['add']) {
            $msg = $showres = $this->_showhtml($catid, $id);
            
            if ($config['relist']) {
                $msg = $this->_categoryhtml($catid, 1, $config);
            }
        } elseif ($isadd == 2 && $config['edit']) {
            $msg = $showres = $this->_showhtml($catid, $id);
            if ($config['relist']) {
                $msg = $this->_categoryhtml($catid, 1, $config);
            }
        }

        //是否更新首页
        if ($config['reindex']) {
            
            $this->_indexhtml();
        }

        return $msg;

    }

    //自动首页
    private function _indexhtml()
    {
        $html = $this->_pcurl(SITE_URL);
        if ($this->site_info[SITE_ID]['SITE_INDEX_HTML']) {
            if (defined('IS_MOBILE') && IS_MOBILE) {
                // 移动端，当移动端独立域名情况下才生成静态
                if (SITE_MURL != SITE_URL) {
                    file_put_contents(\Phpcmf\Service::L('html')->get_webpath(SITE_ID, 'site', 'mobile/index.html'), $html);
                }
            } else {
                // pc
                file_put_contents(\Phpcmf\Service::L('html')->get_webpath(SITE_ID, 'site', 'index.html'), $html);
            }
            log_message('debug', '生成首页');
        }
    }

    //分类
    private function _categoryhtml($catid, $page = 1, $config = [])
    {
        $msg = '';
        if (!$catid) {
            return $msg . '参数错误';
        }

        $cats = \Phpcmf\Service::L('category', 'module')->get_category('share',SITE_ID);
        $cat = $cats[$catid];

        if ($cat['tid'] != 1) {
            return $msg . '非模块';
        }

        $this->_module_init($cat['mid']);
        $this->module = $this->get_cache('module-' . SITE_ID . '-' . $cat['mid']);

        $pagesize = $config['pages'][$catid]['pagesize'] ? intval($config['pages'][$catid]['pagesize']) : $cat['setting']['template']['pagesize'];
        $mpagesize = $config['pages'][$catid]['mpagesize'] ? intval($config['pages'][$catid]['mpagesize']) : $cat['setting']['template']['mpagesize'];
        $pagesize = ($pagesize && is_numeric($pagesize)) ? intval($pagesize) : 10;
        $mpagesize = ($mpagesize && is_numeric($mpagesize)) ? intval($mpagesize) : 10;

        //是否可分页 父栏目可发内容不处理 2020-11-20
        if (!$cat['child']) {

            $page = 1;
            $total = 0;
            $table = SITE_ID . '_' . $cat['mid'];
            $mid = $cat['mid'];

            $total = $this->_limit_total($catid, $table); //数据总数
            $totalpage = ceil($total / $pagesize); //总页数\

            $ci = \Phpcmf\Service::C();

            //生成分页url html
            for ($i = 1; $i <= $totalpage; $i++) {
                $page = $i;
                $rt = \Phpcmf\Service::L('html', 'mokhtml')->_Create_Category_Html($ci, $mid, $catid);
                $msg = $msg . $rt['msg'];
            }

            //更新父级
            if ($cat['pids']) {
                $pids = explode(',', $cat['pids']);
                $page = 1;
                foreach ($pids as $catid) {
                    if ($catid) {
                        $cat = $cats[$catid];
                        $rt = \Phpcmf\Service::L('html', 'mokhtml')->_Create_Category_Html($ci, $mid, $catid);
                        $msg = $msg . $rt['msg'];
                    }
                }
            }
            log_message('debug', '请求生成栏目页面:'.$catid);
            return $msg;

        }

    }

    //详情
    private function _showhtml($catid, $id)
    {

        $msg = '';

        $cats = \Phpcmf\Service::L('category', 'module')->get_category('share',SITE_ID);
        $cat = $cats[$catid];
        $mid = $cat['mid'];

        $this->_module_init($cat['mid']);
        $this->module = $this->get_cache('module-' . SITE_ID . '-' . $cat['mid']);
        $this->module['category'] = $cats;

        $data = \Phpcmf\Service::M()->db->table(SITE_ID . '_' . $mid)->where("id", $id)->get()->getRowArray();
        if (!$data) {
            return $msg . '文章不存在';
        }
        $_data = \Phpcmf\Service::M()->db->table(SITE_ID . '_' . $mid . '_data_0')->where("id", $id)->get()->getRowArray();
        $data['content'] = $_data['content'] ? htmlspecialchars_decode($_data['content']) : '';

        //静态类2021-11后
        $ci = \Phpcmf\Service::C();

        //存在内容分页
        $page = 1;
        
        if (strpos($data['content'], '<hr class="pagebreak">') !== false) {
            $match = explode('<hr class="pagebreak">', $data['content']);
            $content = [];
            foreach ($match as $i => $t) {
                $content[$page] = $t;
                $rt = \Phpcmf\Service::L('html', 'mokhtml')->_Create_Show_Html($ci, $mid, $id, $page);
                $msg = $msg . $rt['msg'];
                $page++; //下一页
            }
        } else {
            $rt = \Phpcmf\Service::L('html', 'mokhtml')->_Create_Show_Html($ci, $mid, $id, $page);
            $msg = $msg . $rt['msg'];
        }

        log_message('debug', '请求生成详情页面:'.$id);
        return $msg;

    }

    private function _pcurl($url = '')
    {
        if (!$url) {
            return false;
        }

        if (function_exists('file_get_contents')) {
            $data = file_get_contents($url);
        } else {
            $curl = curl_init();
            curl_setopt($curl, CURLOPT_URL, $url);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 5);
            curl_setopt($curl, CURLOPT_BINARYTRANSFER, true);
            curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/5.0 (X11; U; Linux i686; zh-CN; rv:1.9.1.2) Gecko/20120829 Firefox/3.5.2 GTB5');
            curl_setopt($curl, CURLINFO_HEADER_OUT, true);
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
            curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
            $data = curl_exec($curl);
            curl_close($curl);
        }
        return $data;
    }

    private function _mcurl($url = '')
    {
        if (!$url) {
            return false;
        }
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
        curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Linux; U; Android 4.1.1; zh-cn; MI 2S Build/JRO03L) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30 XiaoMi/MiuiBrowser/1.0");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
        $res = curl_exec($ch);
        curl_close($ch);
        return $res;
    }

    private function _limit_total($catid, $table)
    {
        $total = \Phpcmf\Service::M()->db->table($table)->where('catid', $catid)->where('status', 9)->countAllResults();
        $total = $total ?? 0;
        return $total;
    }

}
